<template>
  <div :class="{container: true, landscape}">
    <AnimatedImage :image="image" :width="width" :height="height" :rtl="landscape" class="featured-image" />
    <FeaturedProduct :product="product" class="product" :ltr="landscape" />
  </div>
</template>

<script>
import FeaturedProduct from "@/components/homepage/FeaturedProduct";
import AnimatedImage from "@/components/base/AnimatedImage";

export default {
  name: "FeaturedProductContainer",
  components: {
    FeaturedProduct,
    AnimatedImage
  },
  data() {
    return {
      windowWidth: 1200
    }
  },
  props: {
    landscape: {
      type: Boolean,
      default: false
    },
    image: {
      type: String,
      required: true
    },
    product: {
      type: Object,
      required: true
    }
  },
  computed: {
    width() {
      if (this.windowWidth < 600) {
        return '90vw'
      } else if (this.windowWidth < 950) {
        return this.landscape ? '90vw' : '60vw';
      }
      return this.landscape ? '850px' : '475px';
    },
    height() {
      if (this.windowWidth < 600) {
        return '145vw';
      } else if (this.windowWidth < 950) {
        return this.landscape ? '75vw' : '100vw';
      }
      return this.landscape ? '400px' : '700px';
    }
  },
  methods: {
    sizeChangeHandler() {
      this.windowWidth = window.innerWidth;
    }
  },
  mounted() {
    this.windowWidth = window.innerWidth;
    window.addEventListener('resize', this.sizeChangeHandler);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.sizeChangeHandler);
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.container
  display flex
  justify-content space-between
  align-items center
  @media only screen and (max-width 950px)
    flex-direction column
  &.landscape
    flex-direction row-reverse
    @media only screen and (max-width 1350px)
      flex-direction column
    & .product
      @media only screen and (max-width 1350px)
        align-self flex-start
    & .featured-image
      @media only screen and (max-width 1350px)
        align-self flex-end

.product
  margin-top $xlg
  @media only screen and (max-width 950px)
    align-self flex-end

.featured-image
  @media only screen and (max-width 950px)
    align-self flex-start
</style>